#include "stdafx.h"
#include "dreamwriter_de.h"

dreamwriter_de::dreamwriter_de()
{
	log = false;
}

dreamwriter_de::~dreamwriter_de()
{
	fin.close();
}

void dreamwriter_de::set_log(bool write_log)
{
	log = write_log;
	return;
}

bool dreamwriter_de::get_log()
{
	return log;
}

void dreamwriter_de::set_input_file(std::string input_file)
{
	fin.close();
	fin.open(input_file.c_str(), std::ifstream::in);
	if (!fin.good())
	{
		throw std::exception("Could not open content file.");
	}
}

std::string dreamwriter_de::format_gallery_nunber(unsigned int number)
{
	std::stringstream sstream;
	if (number < 100)
	{
		sstream << "0";
	}
	if (number < 10)
	{
		sstream << "0";
	}
	sstream << number;
	return sstream.str();
}

void dreamwriter_de::read_blog_post()
{
	std::stringstream sstream;

	news_post working_news_post;
	blog_post working_blog_post;
	fin.getline(linebuffer, max_line_length);
	working_news_post.set_date(std::string(linebuffer));
	working_blog_post.set_date(std::string(linebuffer));
	sstream << "blog.html#" << std::string(linebuffer);
	working_news_post.set_link(sstream.str());
	sstream.clear();
	sstream.str("");
	fin.getline(linebuffer, max_line_length);
	working_news_post.set_text(std::string(linebuffer));
	working_blog_post.set_synopsis(std::string(linebuffer));
	sstream << "\t\t\t\t\t\t<p  class=\"blog_text\">";
	fin.getline(linebuffer, max_line_length);
	std::string current_line = std::string(linebuffer);
	bool last_line_full = false;
	while (current_line != "#end blog")
	{
		if (current_line == "")
		{
			sstream << "</p>\n\t\t\t\t\t\t<p  class=\"blog_text\">";
			last_line_full = false;
		}
		else
		{
			if (last_line_full)
			{
				sstream << "<br>";
			}
			sstream << current_line;
			last_line_full = true;
		}
		fin.getline(linebuffer, max_line_length);
		current_line = std::string(linebuffer);
	}
	sstream << "</p>\n";
	working_blog_post.set_text(sstream.str());
	sstream.clear();
	sstream.str("");
	blog_post_collection.push_back(working_blog_post);
	news_post_collection.push_back(working_news_post);
	if (log)
	{
		std::cout << "Read blog post: " << working_blog_post.get_date() << " " << working_blog_post.get_synopsis() << std::endl;
	}

	return;
}

void dreamwriter_de::read_picture()
{
	std::stringstream sstream;

	news_post working_news_post;
	picture working_picture;
	fin.getline(linebuffer, max_line_length);
	working_news_post.set_date(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	working_picture.set_html_file_name(std::string(linebuffer));
	sstream << "gallery/" << std::string(linebuffer);
	working_news_post.set_link(sstream.str());
	sstream.clear();
	sstream.str("");
	fin.getline(linebuffer, max_line_length);
	working_picture.set_pic_file_name(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	sstream << "New picture: \"" << std::string(linebuffer) << "\"";
	working_news_post.set_text(sstream.str());
	sstream.clear();
	sstream.str("");
	working_picture.set_title(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	working_picture.set_alt_atribute(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	working_picture.set_date(std::string(linebuffer));
	sstream << "\t\t\t\t<p id=\"pic_description\">";
	fin.getline(linebuffer, max_line_length);
	std::string current_line = std::string(linebuffer);
	bool last_line_full = false;
	while (current_line != "#end picture")
	{
		if (current_line == "")
		{
			sstream << "</p>\n\t\t\t\t<p id=\"pic_description\">";
			last_line_full = false;
		}
		else
		{
			if (last_line_full)
			{
				sstream << "<br>";
			}
			sstream << current_line;
			last_line_full = true;
		}
		fin.getline(linebuffer, max_line_length);
		current_line = std::string(linebuffer);
	}
	sstream << "</p>\n";
	working_picture.set_description(sstream.str());
	sstream.clear();
	sstream.str("");
	picture_collection.push_back(working_picture);
	news_post_collection.push_back(working_news_post);

	if (log)
	{
		std::cout << "Read picture: " << working_picture.get_title() << std::endl;
	}

	return;
}

void dreamwriter_de::read_update()
{
	news_post working_news_post;
	fin.getline(linebuffer, max_line_length);
	working_news_post.set_date(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	working_news_post.set_text(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	working_news_post.set_link(std::string(linebuffer));
	fin.getline(linebuffer, max_line_length);
	news_post_collection.push_back(working_news_post);

	if (log)
	{
		std::cout << "Read update: " << working_news_post.get_date() << " " << working_news_post.get_text() << std::endl;
	}
	return;
}

void dreamwriter_de::write_index()
{
	std::ofstream index_out("output\\index.html", std::ofstream::out);
	if (!index_out.good())
	{
		index_out.close();
		throw std::exception("Could not open index.html for output.");
	}

	index_out << "<!DOCTYPE html>" << std::endl;
	index_out << "<html>" << std::endl;
	index_out << "<head>" << std::endl;
	index_out << "\t<title>dreamwriter</title>" << std::endl;
	index_out << "\t<link type=\"text/css\" rel=\"stylesheet\" href=\"dreamwriter.css\">" << std::endl;
	index_out << "</head>" << std::endl;
	index_out << "<body>" << std::endl;
	index_out << "\t<div id=\"main_page\">" << std::endl;
	index_out << "\t\t<div id=\"main_title\">" << std::endl;
	index_out << "\t\t\tThe Dreamwriter" << std::endl;
	index_out << "\t\t</div>" << std::endl;
	index_out << "\t\t<div class=\"clearfix\">" << std::endl;
	index_out << "\t\t\t<iframe src=\"main_nav.html\" title = \"Navigation\" id=\"nav\"></iframe>" << std::endl;
	index_out << "\t\t\t<div id=\"content\">" << std::endl;
	for (int i = news_post_collection.size() - 1; i >= 0; --i)
	{
		index_out << "\t\t\t\t<div class=\"news_post\">" << std::endl;
		index_out << "\t\t\t\t\t<a href=\"" << news_post_collection[i].get_link() << "\" name=\"" << i << ":" << news_post_collection[i].get_date() << "\" class=\"news_title\">" << news_post_collection[i].get_date() << "</a>" << std::endl;
		index_out << "\t\t\t\t\t<p class=\"news_text\">" << news_post_collection[i].get_text() << "</p>" << std::endl;
		index_out << "\t\t\t\t</div>" << std::endl;
	}
	index_out << "\t\t\t</div>" << std::endl;
	index_out << "\t\t</div>" << std::endl;
	index_out << "\t</div>" << std::endl;
	index_out << "</body>" << std::endl;
	index_out << "</html>" << std::endl;

	index_out.close();

	if (log)
	{
		std::cout << "Wrote index.html" << std::endl << std::endl;
	}

	return;
}

void dreamwriter_de::write_blog()
{
	std::ofstream blog_out("output\\blog.html", std::ofstream::out);
	if (!blog_out.good())
	{
		blog_out.close();
		throw std::exception("Could not open blog.html for output.");
	}

	blog_out << "<!DOCTYPE html>" << std::endl;
	blog_out << "<html>" << std::endl;
	blog_out << "<head>" << std::endl;
	blog_out << "\t<title>dreamwriter</title>" << std::endl;
	blog_out << "\t<link type=\"text/css\" rel=\"stylesheet\" href=\"dreamwriter.css\">" << std::endl;
	blog_out << "</head>" << std::endl;
	blog_out << "<body>" << std::endl;
	blog_out << "\t<div id=\"main_page\">" << std::endl;
	blog_out << "\t\t<div id=\"sub_title\">" << std::endl;
	blog_out << "\t\t\tWords of Wisdom" << std::endl;
	blog_out << "\t\t</div>" << std::endl;
	blog_out << "\t\t<div class=\"clearfix\">" << std::endl;
	blog_out << "\t\t\t<iframe src=\"main_nav.html\" title = \"Navigation\" id=\"nav\"></iframe>" << std::endl;
	blog_out << "\t\t\t<div id=\"content\">" << std::endl;
	for (int i = blog_post_collection.size() - 1; i >= 0; --i)
	{
		blog_out << "\t\t\t\t<div class=\"blog_post\">" << std::endl;
		blog_out << "\t\t\t\t\t<a name=\"" << blog_post_collection[i].get_date() << "\" class=\"blog_title\">" << blog_post_collection[i].get_date() << "</a>" << std::endl;
		blog_out << blog_post_collection[i].get_text();
		blog_out << "\t\t\t\t</div>" << std::endl;
	}
	blog_out << "\t\t\t</div>" << std::endl;
	blog_out << "\t\t</div>" << std::endl;
	blog_out << "\t</div>" << std::endl;
	blog_out << "</body>" << std::endl;
	blog_out << "</html>" << std::endl;

	blog_out.close();

	if (log)
	{
		std::cout << "Wrote blog.html" << std::endl << std::endl;
	}

	return;
}

void dreamwriter_de::write_pictures()
{
	for (unsigned int i = 0; i < picture_collection.size(); ++i)
	{
		std::stringstream sstream;
		sstream << "output\\gallery\\" << picture_collection[i].get_html_file_name();
		std::ofstream picture_out(sstream.str().c_str(), std::ofstream::out);
		sstream.clear();
		sstream.str("");
		if (!picture_out.good())
		{
			picture_out.close();
			sstream << "Could not open picture html file " << picture_collection[i].get_html_file_name() << " for output.";
			throw std::exception(sstream.str().c_str());
		}

		picture_out << "<!DOCTYPE html>" << std::endl;
		picture_out << "<html>" << std::endl;
		picture_out << "<head>" << std::endl;
		picture_out << "\t<title>dreamwriter</title>" << std::endl;
		picture_out << "\t<link type=\"text/css\" rel=\"stylesheet\" href=\"../dreamwriter.css\">" << std::endl;
		picture_out << "</head>" << std::endl;
		picture_out << "<body>" << std::endl;
		picture_out << "\t<div id=\"main_page\">" << std::endl;
		picture_out << "\t\t<div id=\"sub_title\">" << std::endl;
		picture_out << "\t\t\t" << picture_collection[i].get_title() << std::endl;
		picture_out << "\t\t</div>" << std::endl;
		picture_out << "\t\t<div class=\"clearfix\">" << std::endl;
		picture_out << "\t\t\t<iframe src=\"../main_nav.html\" title = \"Navigation\" id=\"nav\"></iframe>" << std::endl;
		picture_out << "\t\t\t<div id=\"content\">" << std::endl;
		picture_out << "\t\t\t\t<a href=\"../pics/" << picture_collection[i].get_pic_file_name() << "\"><img id=\"pic\" src=\"../pics/" << picture_collection[i].get_pic_file_name() << "\" alt=\"" << picture_collection[i].get_alt_atribute() << "\"></a>" << std::endl;
		picture_out << "\t\t\t\t<p id=\"pic_title\">" << picture_collection[i].get_title() << "</p>" << std::endl;
		picture_out << "\t\t\t\t<p id=\"pic_date\">" << picture_collection[i].get_date() << "</p>" << std::endl;
		picture_out << picture_collection[i].get_description();
		picture_out << "\t\t\t\t<p id=\"pic_copyright\">By Sven Thor, licensed under <a href=\"https://creativecommons.org/licenses/by/4.0/legalcode\">creative commons 4.0 BY</a></p>";
		picture_out << "\t\t\t\t<iframe src=\"gallery" << format_gallery_nunber(i / 8 + 1) << ".html\" title=\"gallery\" id=\"gallery\"></iframe>" << std::endl;
		picture_out << "\t\t\t</div>" << std::endl;
		picture_out << "\t\t</div>" << std::endl;
		picture_out << "\t</div>" << std::endl;
		picture_out << "</body>" << std::endl;
		picture_out << "</html>" << std::endl;

		picture_out.close();

		if (log)
		{
			std::cout << "Wrote " << picture_collection[i].get_html_file_name() << std::endl << std::endl;
		}

	}

	return;
}

void dreamwriter_de::write_galleries()
{
	std::stringstream sstream;

	unsigned int picture_index = 0;
	for (unsigned int i = 0; i < (((picture_collection.size() - 1) / 8) + 1); ++i)
	{
		sstream << "output\\gallery\\gallery" << format_gallery_nunber(i + 1) << ".html";
		std::ofstream gallery_out(sstream.str().c_str(), std::ofstream::out);
		sstream.clear();
		sstream.str("");
		if (!gallery_out.good())
		{
			gallery_out.close();
			sstream << "Could not open gallery " << i + 1 << " html file for output.";
			throw std::exception(sstream.str().c_str());
		}

		gallery_out << "<!DOCTYPE html>" << std::endl;
		gallery_out << "<html>" << std::endl;
		gallery_out << "<head>" << std::endl;
		gallery_out << "\t<title>gallery " << format_gallery_nunber(i + 1) << "</title>" << std::endl;
		gallery_out << "\t<link type=\"text/css\" rel=\"stylesheet\" href=\"../dreamwriter.css\">" << std::endl;
		gallery_out << "\t<style>" << std::endl;
		gallery_out << "\t\tbody {" << std::endl;
		gallery_out << "\t\t\tbackground: white;" << std::endl;
		gallery_out << "\t\t\tbackground-image: url();" << std::endl;
		gallery_out << "\t\t}" << std::endl;
		gallery_out << "\t</style>" << std::endl;
		gallery_out << "</head>" << std::endl;
		gallery_out << "<body>" << std::endl;
		gallery_out << "\t<div id=\"gallery_number\">";
		for (unsigned int j = 0; j < (((picture_collection.size() - 1) / 8) + 1); ++j)
		{
			if (j != 0)
			{
				gallery_out << " | ";
			}

			if (i == j)
			{
				gallery_out << "<span id=\"selected_gallery\">" << j + 1 << "</span>";
			}
			else
			{
				gallery_out << "<a href=\"gallery" << format_gallery_nunber(j + 1) << ".html\">" << j + 1 << "</a>";
			}
		}
		gallery_out << "</div>" << std::endl;
		gallery_out << "\t<div class=\"gallery_arrow\">";
		if (i != 0)
		{
			gallery_out << "<a href=\"gallery" << format_gallery_nunber(i) << ".html\"><img src=\"gallery_arrow_left.png\" alt=\"navigation arrow left\" class=\"gallery_arrow_graphic\"></a>";
		}
		gallery_out << "</div>" << std::endl;

		for (unsigned int j = 0; j < 8; ++j)
		{
			if (picture_index < picture_collection.size())
			{
				gallery_out << "\t<div class=\"gallery_thumbnail\"><a href=\"" << picture_collection[picture_index].get_html_file_name() << "\" target=\"_parent\"><img src=\"../pics/t_" << picture_collection[picture_index].get_pic_file_name() << "\" alt=\"" << picture_collection[picture_index].get_title() << "\" class=\"gallery_thumbnail_graphic\"></a></div>" << std::endl;
				++picture_index;
			}
			else
			{
				gallery_out << "\t<div class=\"gallery_thumbnail\"></div>" << std::endl;
			}
		}

		gallery_out << "\t<div class=\"gallery_arrow\">";
		if ((i+1) != (((picture_collection.size() - 1) / 8) + 1))
		{
			gallery_out << "<a href=\"gallery" << format_gallery_nunber(i + 2) << ".html\"><img src=\"gallery_arrow_right.png\" alt=\"navigation arrow right\" class=\"gallery_arrow_graphic\"></a>";
		}
		gallery_out << "</div>" << std::endl;

		gallery_out << "</body>" << std::endl;
		gallery_out << "</html>" << std::endl;

		gallery_out.close();

		if (log)
		{
			std::cout << "Wrote gallery " << i + 1 << std::endl << std::endl;
		}
	}

	return;
}

void dreamwriter_de::write_nav()
{
	std::ofstream nav_out("output\\main_nav.html", std::ofstream::out);
	if (!nav_out.good())
	{
		nav_out.close();
		throw std::exception( "Could not open main_nav.html for output.");
	}

	nav_out << "<!DOCTYPE html>" << std::endl;
	nav_out << "<html>" << std::endl;
	nav_out << "<head>" << std::endl;
	nav_out << "\t<title>Navigation</title>" << std::endl;
	nav_out << "\t<style>" << std::endl;
	nav_out << "\t\tbody{" << std::endl;
	nav_out << "\t\tbackground: white;" << std::endl;
	nav_out << "\t\tbackground-image: url();" << std::endl;
	nav_out << "\t\tmargin-bottom:0px;" << std::endl;
	nav_out << "\t\tmargin-top: 0px;" << std::endl;
	nav_out << "\t\t}" << std::endl;
	nav_out << "\t</style>" << std::endl;
	nav_out << "</head>" << std::endl;
	nav_out << "<body>" << std::endl;
	nav_out << "\t<a href=\"index.html\" target=\"_parent\">home</a><br>" << std::endl;
	nav_out << "\t<a href=\"blog.html\" target=\"_parent\">blog</a><br>" << std::endl;
	nav_out << "\t<a href=\"gallery/" << picture_collection[picture_collection.size() - 1].get_html_file_name() << "\" target=\"_parent\">pictures</a><br>" << std::endl;
	nav_out << "\t<a href=\"words.html\" target=\"_parent\">stories</a><br>" << std::endl;
	nav_out << "\t<a href=\"software.html\" target=\"_parent\">games, mods & software</a><br>" << std::endl;
	nav_out << "\t<a href=\"music.html\" target=\"_parent\">music</a><br>" << std::endl;
//	nav_out << "\t<a href=\"guestbook\" target=\"_parent\">guestbook</a><br>" << std::endl;
	nav_out << "\t<a href=\"dreamwriter_rss.xml\" target=\"_parent\"><img src=\"rss-icon.png\"> RSS feed</a><br>" << std::endl;
	nav_out << "\t<br>" << std::endl;
	nav_out << "\tcontact:dreamwriter@dreamwriter.de" << std::endl;
	nav_out << "</body>" << std::endl;
	nav_out << "</html>" << std::endl;

	nav_out.close();

	if (log)
	{
		std::cout << "Wrote main_nav.html" << std::endl << std::endl;
	}

	return;
}

void dreamwriter_de::write_rss()
{
	std::ofstream rss_out("output\\dreamwriter_rss.xml", std::ofstream::out);
	if (!rss_out.good())
	{
		rss_out.close();
		throw std::exception( "Could not open dreamwriter_rss.xml for output.");
	}

	rss_out << "<rss version=\"2.0\">" << std::endl;
	rss_out << "\t<channel>" << std::endl;
	rss_out << "\t\t<title>dreamwriter.de</title>" << std::endl;
	rss_out << "\t\t<link>https://www.dreamwriter.de</link>" << std::endl;
	rss_out << "\t\t<description>Personal homepage of Sven Thor. Mostly art, some writing and software projects.</description>" << std::endl;

	for(unsigned int i=0; i<10; ++i)
	{
		rss_out << "\t\t<item>" << std::endl;
		rss_out << "\t\t\t<title>" << news_post_collection[news_post_collection.size()-i-1].get_text() << "</title>" << std::endl;
		rss_out << "\t\t\t<link>" << "https://www.dreamwriter.de/" << news_post_collection[news_post_collection.size()-i-1].get_link() << "</link>" << std::endl;
		//date
		rss_out << "\t\t</item>" << std::endl;
	}

	rss_out << "</channel>" << std::endl;
	rss_out << "</rss>" << std::endl;

	rss_out.close();

	if (log)
	{
		std::cout << "Wrote dreamwriter_rss.xml" << std::endl << std::endl;
	}

	return;
}

void dreamwriter_de::create_dreamwriter_de()
{
	if (!fin.good())
	{
		throw std::exception("No content file opened when trying to create site.");
	}

	while (fin.good())
	{
		fin.getline(linebuffer, max_line_length);
		std::string entry_type = std::string(linebuffer);
		if (entry_type == "#blog")
		{
			read_blog_post();
		}
		else if (entry_type == "#picture")
		{
			read_picture();
		}
		else if (entry_type == "#update")
		{
			read_update();
		}
	}

	if (log)
	{
		std::cout << std::endl;
	}

	write_index();
	write_blog();
	write_pictures();
	write_galleries();
	write_nav();
	write_rss();

	if (log)
	{
		std::cout << std::endl << "Done" << std::endl;
	}

	return;
}